# React-Ionic

[![Join the chat at https://gitter.im/pors/reactionic](https://badges.gitter.im/pors/reactionic.svg)](https://gitter.im/pors/reactionic?utm_source=badge&utm_medium=badge&utm_campaign=pr-badge&utm_content=badge) [![NPM Version](https://img.shields.io/npm/v/reactionic.svg)](https://www.npmjs.com/package/reactionic) [![NPM Downloads](https://img.shields.io/npm/dm/reactionic.svg)](https://www.npmjs.com/package/reactionic)

## React and Ionic: a Perfect Match

[React](https://facebook.github.io/react/) and [Ionic](http://ionicframework.com/) are a great combination:

* React is the **best thing ever** that happened to front-end development
* Ionic allows you to **quickly build iOS and Android apps** that are indistinguishable from native apps.

There are other options to create hybrid mobile apps, but Ionic is the most robust and mature. So if you prefer React over Angular, give React-Ionic a try!

## Is this for me?

React-Ionic is useful for you if you:

* Want to create an iOS and/or Android app coding in **Javascript**.
* Like **React**, or don't mind learning it (you won't regret it; ask me for how to get started).
* Optionally: Use **Meteor** (this is basically a clone of [Meteoric](http://meteoric.github.io/), but without a dependency on Meteor).

## Demo

[Kitchen sink demo](http://reactionic.github.io/#demo) showing off all features ([source](https://github.com/reactionic/reactionic-kitchensink))

## Quick Start

If you know what you are doing: React-Ionic is available as an NPM package that can be added to your package.json

    npm install reactionic --save
    
Or just follow the steps below:

### Step 1: download

The easiest way to start is to download the [kitchen sink demo](https://github.com/reactionic/reactionic-kitchensink), and run it locally (see the [kitchensink README](https://github.com/reactionic/reactionic-kitchensink/blob/master/README.md) how) to try it out.

### Step 2: code

There is no step 2. Just go ahead and change things to make it your own. Have a look at the [guide](https://github.com/reactionic/reactionic/blob/master/GUIDE.md) for more detail.

## Status

First release is available for use. We're working on support for Ionic v2, no ETA yet.

## Guide

A detailed description of each component can be found in the [guide](https://github.com/reactionic/reactionic/blob/master/GUIDE.md).

## Contribute

I need your help to improve this library.

* If you want to patch a bug: create a [pull request]()
* If you want to make a more substantial contribution, please **contact me**: mark (a) pors.net

Looking forward to your contribution! If you have any questions about it, just drop me an email.


## Credits

Inspiration and code was "borrowed" from: 

* [Nick Wientge](https://github.com/meteoric/meteor-ionic)
* [Sam Corcos](https://github.com/samcorcos)

Contributors:

* [Mark Pors](https://github.com/pors/)
* [Gabriel García Seco](https://github.com/gabrielseco)
* [Charlie van de Kerkhof](https://github.com/primeminister)
* [John Slemmer](https://github.com/johnslemmer)

**Thanks guys!**

## License

[Apache License, Version 2.0](https://github.com/reactionic/reactionic/blob/master/LICENSE)
